searchNodes=[{"doc":"TranslaTable is a helper library for creating a translation schema inside your ecto schema.Translation Inside your config.exs add your locale configconfig :transla_table, :config, locale_schema: MyApp.Locale To define a translation schema it just need to use the TranslaTable helper inside your schema to be translateddefmodule MyApp.Post do use Ecto.Schema use TranslaTable.Schema, translation_schema: MyApp.PostTranslation import Ecto.Changeset alias MyApp.PostTranslation schema &quot;post&quot; do field :title, :string field :description, :string field :author, :string field :slug, :string has_many_translations() timestamps() end @doc false def changeset(post, attrs) do post |&gt; cast(attrs, [:title, :description, :author, :slug]) |&gt; cast_translation() end end Then create the translation moduledefmodule MyApp.PostTranslation use TranslaTable, schema: MyApp.Post, fields: [:title, :description, :slug] end Then the TranslaTable Macro will create a schema with the given fields and make the relation with your Locale schema.","ref":"TranslaTable.html","title":"TranslaTable","type":"module"},{"doc":"Query helper when dealing internationalized data.","ref":"TranslaTable.Query.html","title":"TranslaTable.Query","type":"module"},{"doc":"","ref":"TranslaTable.Query.html#assert_schema!/1","title":"TranslaTable.Query.assert_schema!/1","type":"function"},{"doc":"Create a query to localize an entity from database.Example You can create your own functions for composing queries.defmodule MyApp.Blog.Post do import Ecto.Query import TranslaTable.Query alias MyApp.Post alias MyApp.Repo def run(filters) do base_query() |&gt; localize_query(filters[&quot;locale&quot;]) |&gt; filter_by_title(filters) |&gt; Repo.all() end def base_query() do from b in Post end def filter_by_title(query, %{title: title}) do from b in query, where: title == ^title end def filter_by_title(query, _), do: query end The run method will return your data translated based on the locale passed in the filters. This locale parameter should be the reference id of your Locale table. The method filter_by_title is not filtering by the localized value. If you want all your filters to be localized, It's recomended to structure your module in this way:defmodule MyApp.Blog.Post do import Ecto.Query import TranslaTable.Query alias MyApp.Post alias MyApp.Repo def run(filters) do base_query() |&gt; localize(filters) |&gt; filter_by_title(filters) |&gt; Repo.all() end def base_query() do from b in Post end def localize(query, %{locale: locale}) do localize_query(query, locale) end def localize(query, _params), do: query def filter_by_title(query, %{title: title, locale: _}) do from [p, translations: tr] in query, # This is the name binding to the translations (joined by the localize method) where: not is_nil(tr.title) and tr.title == ^title, or_where: not is_nil(p.title) and p.title == ^title end # This will be the default method when the locale is not added as an argument def filter_by_title(query, %{title: title}) do from b in query, where: title == ^title end def filter_by_title(query, _), do: query end This way the queries are composable by locale and It's flexible enough for not using the locale argument at all.","ref":"TranslaTable.Query.html#localize_query/2","title":"TranslaTable.Query.localize_query/2","type":"macro"},{"doc":"TranslaTable.Schema will help casting translation module into your schema.Examples You can define your schema module with the TranslaTable.Schema macro to cast and define the has many association:defmodule MyApp.Post do use Ecto.Schema use TranslaTable.Schema, translation_schema: MyApp.PostTranslation import Ecto.Changeset schema &quot;post&quot; do field :title, :string field :description, :string field :author, :string field :slug, :string has_many_translations() timestamps() end @doc false def changeset(post, attrs) do post |&gt; cast(attrs, [:title, :description, :author, :slug]) |&gt; cast_translation() end end","ref":"TranslaTable.Schema.html","title":"TranslaTable.Schema","type":"module"},{"doc":"","ref":"TranslaTable.Schema.html#cast_translation/1","title":"TranslaTable.Schema.cast_translation/1","type":"macro"},{"doc":"","ref":"TranslaTable.Schema.html#has_many_translations/0","title":"TranslaTable.Schema.has_many_translations/0","type":"macro"},{"doc":"TranslaTableTranslaTableInstallationLocale SchemaCreating locale migration and schemaCreating migration for the entity to be translatedTranslate SchemasQuerying dataLicenseTranslaTable is a thin wrapper around Ecto library to provide internationalizable entities and a way to query localized data. See the documentation on HexDocs.","ref":"readme.html","title":"TranslaTable","type":"extras"},{"doc":"Add the TranslaTable package in your mix.exs:def deps do [ {:transla_table, &quot;~&gt; 0.3&quot;} ] end","ref":"readme.html#installation","title":"TranslaTable - Installation","type":"extras"},{"doc":"You need to create a Locale table and schema to be used and define the locales available for translation.Creating locale migration and schemadefmodule MyApp.CreateLocale do use Ecto.Migration def change do create table(:locale, primary_key: false) do add :id, :string, size: 10, primary_key: true # added as string just to reference the primary key as &quot;en&quot;, &quot;es&quot;, &quot;pt&quot;, etc add :name, :string, null: false timestamps() end end end defmodule MyApp.Locale do @moduledoc &quot;&quot;&quot; Locale Schema &quot;&quot;&quot; use Ecto.Schema import Ecto.Changeset @primary_key {:id, :string, autogenerate: false} schema &quot;locale&quot; do field :name, :string timestamps() end endThen Inside your config.exs add your locale config config :transla_table, :config, locale_schema: MyApp.Locale Creating migration for the entity to be translatedFor example, if you have a Post table and want it to be internationalized, create the table which will make the relation between post and locale:defmodule MyApp.CreatePostTranslation do use Ecto.Migration def change do create table(:post_translation) do add :post_id, references(:post, on_delete: :delete_all) add :locale_id, references(:locale, type: :string, on_delete: :delete_all) # fields to translate in the Post table add :title, :string add :description, :string add :slug, :string timestamps() end create unique_index(:post_translation, [:post_id, :locale_id]) end end","ref":"readme.html#locale-schema","title":"TranslaTable - Locale Schema","type":"extras"},{"doc":"Then in your Post module you define the translation methods using the TranslaTable helper inside your schema to be translateddefmodule MyApp.Post do use Ecto.Schema use TranslaTable.Schema, translation_schema: MyApp.PostTranslation import Ecto.Changeset schema &quot;post&quot; do field :title, :string field :description, :string field :author, :string field :slug, :string has_many_translations() timestamps() end @doc false def changeset(post, attrs) do post |&gt; cast(attrs, [:title, :description, :author, :slug]) |&gt; cast_translation() end endFinally create the translation module which will automatically map the fields within the Post schemadefmodule MyApp.PostTranslation use TranslaTable, schema: MyApp.Post, fields: [:title, :description, :slug] endthen this will create a Translation module with the relations and fields.","ref":"readme.html#translate-schemas","title":"TranslaTable - Translate Schemas","type":"extras"},{"doc":"Using the same example above, it is possible to query data to return only localized fields.defmodule MyApp.PostContext do import Ecto.Query import TranslaTable.Query alias MyApp.Post alias MyApp.Repo def list_all() do from(p in Post) |&gt; preload(:translations) |&gt; Repo.all() end def list_localized(locale_id) do from(p in Post) |&gt; localize_query(locale_id) |&gt; Repo.all() end end ... ## then you can list the posts with translations iex&gt; MyApp.PostContext.list_all() [ %MyApp.Post{ description: &quot;Description&quot;, title: &quot;Blog Post&quot;, translations: [ %MyApp.PostTranslation{ description: &quot;Description&quot;, title: &quot;Blog Post&quot; }, %MyApp.PostTranslation{ description: &quot;Descrição&quot;, title: &quot;Post do Blog&quot; } ] } ] # also you can define which locale you want to return iex&gt; MyApp.PostContext.list_localized(&quot;pt&quot;) [ %MyApp.Post{ description: &quot;Descrição&quot;, title: &quot;Post do Blog&quot; } ]","ref":"readme.html#querying-data","title":"TranslaTable - Querying data","type":"extras"},{"doc":"Copyright 2021 Paulo Henrique de Oliveira CuradoLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License athttp://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"TranslaTable - License","type":"extras"}]